/*
    wav_read.cc - taken from wav-tools 1.1
    Copyright (C) by Colin Ligertwood

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    
    Changes:
    
    11 March 1999: Alexander Knig
    -added license hint
*/

/* operations for verifying and reading wav files. */

#include <stdio.h>
#include <fcntl.h>
#include <sys/stat.h>
#include "wav_file.h"
#include <unistd.h>


	/* wav header is 44 bytes long */
int open_wav(char *header, char file_name[]){
	int handle;
	handle = open(file_name, O_RDONLY, S_IREAD);
	read(handle,(char *) header, 44);

	return(handle);
}

short get_wav_format(wav_sig *info){
	return(*(short *)&info->head[20]);
}

	/* mono or stereo */
short get_wav_channels(wav_sig *info){
	return(*(short *)&info->head[22]);
}

	/* sample rate */
long get_wav_srate(wav_sig *info){
	return(*(long *)&info->head[24]);
}
long get_wav_bps(wav_sig *info){
	return(*(long *)&info->head[28]);
}

short get_wav_blkalign(wav_sig *info){
	return (*(long *)&info->head[32]);
}

	/* sample depth (8bit or 16bit) */
short get_wav_depth(wav_sig *info){
	return((short)info->head[34]);
}

	/* data section only  ==  totalfile - 44 */
long get_wav_len(wav_sig *info){
	return (*(long *)&info->head[40]);	
}


int init_wav_read(char file_name[], wav_sig *info){
	info->handle = open_wav(info->head, file_name);
	strcpy(info->name,file_name);
	info->chans = get_wav_channels(info);
 	info->srate = get_wav_srate(info);
 	info->bps   = get_wav_bps(info);
 	info->blkalign = get_wav_blkalign(info);
	info->depth = get_wav_depth(info);
	info->len   = get_wav_len(info);
	return(info->handle);
	
}
