/*
    wav_write.cc - taken from wav-tools 1.1
    Copyright (C) by Colin Ligertwood

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    
    Changes:
    
    11 March 1999: Alexander Knig
    -added license hint
    -added return statement in rewrite_head
*/

#include <stdio.h>
#include <fcntl.h>
#include <signal.h>
#include <sys/soundcard.h>
#include "wav_file.h"
#include <unistd.h>

void init_head(wav_sig *info){
	strcpy(info->head, "RIFF    WAVEfmt                     data    ");
	*(long  *)&info->head[4]  = (info->sofar + 32);
	*(long  *)&info->head[16] = 16;
	*(short *)&info->head[20] = 1;
	*(short *)&info->head[22] = info->chans;
	*(long  *)&info->head[24] = info->srate;
	*(long  *)&info->head[28] = info->bps;
	*(short *)&info->head[32] = info->blkalign;
	*(short *)&info->head[34] = info->depth;
	*(long  *)&info->head[40] = info->sofar;
}

int open_wav_rec(wav_sig *info){
	info->handle = open(info->name, O_CREAT | O_RDWR, 0644);
	init_head(info);
	write(info->handle, info->head, 44);
	return(info->handle);
}

int rewrite_head(wav_sig *info){
	lseek(info->handle, 0, SEEK_SET);
	init_head(info);
	write(info->handle, info->head, 44);
	/* make -Wall shut_up */
	return(0);
}
